<?php
/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme.txt .

****************************************

 :

1.0	2006.02.26 RXL (rxl@mail.ru)
      .

1.1	2006.03.19 RXL (rxl@mail.ru)
      3.0.2.

*/

class core__session_db
{
    var $_table;
    var $_db;
    var $_session;

    function session_open($path, $name)
    {
	global $core;

	$this->_db = $core->get_module('db');
	if (!$this->_db)
	    return false;

	$this->_session = $core->get_module('session');
	$this->_table = $this->_db->get_table( _g('engine.session.db_table'));
	return true;
    }

    function session_close()
    {
	return true;
    }

    function session_read($sid)
    {
	$this->_session->sid = $sid;

	$tries = _g('engine.session.locking_tries');
	$tries = $tries ? $tries : 4;

	for($try = 0; $try < $tries; $try++)
	{
	    if (!$this->_db->query(
		    "UPDATE $this->_table SET locked='Y',lock_time=NULL" .
		    " WHERE sid='$sid' AND (locked='' OR" .
		    " (locked='Y' AND lock_time < DATE_ADD(NOW(),INTERVAL -" .
		    _g('engine.session.lock_maxtime') . " SECOND)))"
		))
		user_error($this->_db->err, ERROR);
	    if ($this->_db->rows)
		break;

	    if ($try == 0)
	    {
		$res = $this->_db->query("SELECT sid FROM $this->_table WHERE sid='$sid'");
		if (!$res)
		    user_error($this->_db->err, ERROR);
		if (!$res->rows)
		{
		    if ($this->_db->query(
			    "INSERT INTO $this->_table (sid,ctime,lock_time,locked)" .
			    " VALUES ('$sid',NULL,NULL,'Y')"
			))
			break;
		    user_error($this->_db->err, ERROR);
		}
		$res->free();
	    }

	    usleep( _g('engine.session.locking_sleep') * 1000000);
	    continue;
	}

	if ($try == $tries)
	{
	    $this->_session->no_store = true;
	}

	$res = $this->_db->query("SELECT data FROM $this->_table WHERE sid='$sid'");
	$data = $res->get_value();

	return $data;
    }

    function session_write($sid, $data)
    {
	if ($this->_session->no_store)
	    return true;

	$data = $this->_db->esc($data);
	return $this->_db->query("UPDATE $this->_table SET locked='',data=$data WHERE sid='$sid'");
    }

    function session_delete($sid)
    {
	return $this->_db->query("DELETE FROM $this->_table WHERE sid='$sid'");
    }

    function session_gc($lifetime)
    {
	$this->_db->query("DELETE FROM $this->_table WHERE atime < DATE_ADD(NOW(),INTERVAL -$lifetime SECOND)");
    }
}

?>