<?php
/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme.txt .

****************************************

 :

1.0	2006.03.19 RXL (rxl@mail.ru)
      .


*/

class core__session_std
{
    var $_path = '';
    var $_session;

    function session_open($path, $name)
    {
	global $core;

	$this->_session = $core->get_module('session');
	$this->_path = $path;
	return true;
    }

    function session_close()
    {
	return true;
    }

    function session_read($sid)
    {
	$this->_session->sid = $sid;

	$file = $this->_path . "/" . _g('engine.session.file_prefix') .
	    $sid . _g('engine.session.file_postfix');
	if (!file_exists($file))
	    return "";
	if (!($fd = @fopen($file, 'rb')))
	    return "";
	$data = fread($fd, filesize($file));
	fclose($fd);
	return $data;
    }

    function session_write($sid, $data)
    {
	if ($this->_session->no_store)
	    return true;

	$file = $this->_path . "/" . _g('engine.session.file_prefix') .
	    $sid . _g('engine.session.file_postfix');
	if (!($fd = fopen($file, 'wb')))
	    return false;
	$res = fwrite($fd, $data);
	fclose($fd);
	return $res;
    }

    function session_delete($sid)
    {
	$file = $this->_path . "/" . _g('engine.session.file_prefix') .
	    $sid . _g('engine.session.file_postfix');
	return unlink($file);
    }

    function session_gc($lifetime)
    {
	if (!($dir = opendir($this->_path)))
	    return false;
	while($file = readdir($dir))
	{
	    $filepath = "$this->_path/$file";
	    if (!is_file($filepath))
		continue;
	    if (!preg_match('/^' . _g('engine.session.file_prefix') . '.*' .
		_g('engine.session.file_postfix') . '/', $file))
		continue;
	    $time = filemtime($filepath); // modify time!
	    $now = time();
	    if ($time + $lifetime < $now)
		unlink($filepath);
	}
	closedir($dir);
	return true;
    }

}

?>